<!-- the line below needs to be an empty line C: (its because kramdown isnt
     that smart and dearly wants an empty line before a heading to be able to
     display it as such, e.g. website) -->

# 자바로 구현된 디자인 패턴

![Java CI with Maven](https://github.com/iluwatar/java-design-patterns/workflows/Java%20CI%20with%20Maven/badge.svg)[](https://raw.githubusercontent.com/iluwatar/java-design-patterns/master/LICENSE.md)![License MIT](https://img.shields.io/badge/license-MIT-blue.svg)[](https://sonarcloud.io/dashboard?id=iluwatar_java-design-patterns)![Join the chat at https://gitter.im/iluwatar/java-design-patterns](https://badges.gitter.im/Join%20Chat.svg)

<!-- ALL-CONTRIBUTORS-BADGE:START - Do not remove or modify this section -->

[](#contributors-)![All Contributors](https://img.shields.io/badge/all_contributors-133-orange.svg?style=flat-square)

<!-- ALL-CONTRIBUTORS-BADGE:END -->

# 소개

디자인 패턴은 개발자가 응용 프로그램이나 시스템을 디자인할 때 일반적인 문제를 해결하는 데 사용할 수 있는 가장 정석적인 방법입니다.

디자인 패턴은 테스트되고 입증된 개발 패러다임을 제공하여 개발 프로세스 속도를 높일 수 있습니다.

디자인 패턴을 사용하면 주요 문제를 유발하는 미묘한 이슈들을 방지하는 데 도움이 되며 또한 패턴에 익숙한 개발자와 아키텍트의 코드 가독성을 향상시킵니다.

# 시작하기

이 사이트는 Java 디자인 패턴을 설명합니다. 이 솔루션은 오픈 소스 커뮤니티의 경험이 많은 개발자와 설계자가 개발했습니다. 패턴은 높은 수준의 설명이나 소스 코드를 통해 찾아볼 수 있습니다. 소스 코드 예제는 잘 설명되어 있으며 특정 패턴을 구현하는 방법을 알려주는 프로그래밍 튜토리얼로 사용할 수 있습니다. 우리는 가장 널리 알려지고 실무에서 입증된 오픈 소스 Java 기술을 사용합니다.

자료를 살펴보기 전에 다양한 [소프트웨어 설계 원칙](https://java-design-patterns.com/principles/)을 숙지해야 합니다.

모든 디자인 패턴은 가능한 한 심플해야 합니다. 소프트웨어 개발의 KISS, YAGNI 원칙을 지켜야 하며, 문제를 해결할 수 있는 가장 심플한 일을 해야 합니다. 복잡한 디자인 패턴은 실용적이고 확장성을 위해 필요할 때만 도입되어야 합니다.

이러한 개념에 익숙해지면 아래와 같은 방법으로 [사용 가능한 디자인 패턴](https://java-design-patterns.com/patterns/) 중 하나를 선택하여 문제를 해결할 수 있습니다.

- 이름으로 특정 패턴을 검색합니다. 찾는 패턴이 없다면 [여기](https://github.com/iluwatar/java-design-patterns/issues)에서 새 패턴을 요청하세요.
- `Performance`, `Gang of Four` 또는 `Data access` 등의 태그로 검색하세요.
- `Creational`, `Behavioral` 등의 패턴 카테고리로 검색하세요.

이 사이트에서 제공하는 객체 지향 솔루션이 여러분의 아키텍처에 유용하고 사용되고 우리가 개발 한 것만큼 재미있게 배우기를 바랍니다.

# 기여하는 방법

프로젝트에 기여할 의향이 있다면 [developer wiki](https://github.com/iluwatar/java-design-patterns/wiki)에서 관련 정보를 찾을 수 있습니다. [Gitter chatroom](https://gitter.im/iluwatar/java-design-patterns)에서 귀하를 돕고 질문에 답변해 드리겠습니다.

# 특허

이 프로젝트는 MIT 라이센스 조건에 따라 라이센스가 적용됩니다.

# 기여자

<!-- ALL-CONTRIBUTORS-LIST:START - Do not remove or modify this section -->

<!-- prettier-ignore-start -->

<!-- markdownlint-disable -->

<table>
  <tr>
    <td align="center"><a href="https://github.com/iluwatar"><img src="https://avatars1.githubusercontent.com/u/582346?v=4" width="100px;" alt=""><br><sub><b>Ilkka Seppälä</b></sub></a></td>
    <td align="center"><a href="https://github.com/amit1307"><img src="https://avatars0.githubusercontent.com/u/23420222?v=4" width="100px;" alt=""><br><sub><b>amit1307</b></sub></a></td>
    <td align="center"><a href="https://github.com/npathai"><img src="https://avatars2.githubusercontent.com/u/1792515?v=4" width="100px;" alt=""><br><sub><b>Narendra Pathai</b></sub></a></td>
    <td align="center"><a href="https://github.com/fluxw42"><img src="https://avatars1.githubusercontent.com/u/1545460?v=4" width="100px;" alt=""><br><sub><b>Jeroen Meulemeester</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="http://www.joemccarthy.co.uk"><img src="https://avatars0.githubusercontent.com/u/4526195?v=4" width="100px;" alt=""><br><sub><b>Joseph McCarthy</b></sub></a></td>
    <td align="center"><a href="https://github.com/thomasoss"><img src="https://avatars1.githubusercontent.com/u/22516154?v=4" width="100px;" alt=""><br><sub><b>Thomas</b></sub></a></td>
    <td align="center"><a href="https://github.com/anuragagarwal561994"><img src="https://avatars1.githubusercontent.com/u/6075379?v=4" width="100px;" alt=""><br><sub><b>Anurag Agarwal</b></sub></a></td>
    <td align="center"><a href="https://markusmo3.github.io"><img src="https://avatars1.githubusercontent.com/u/3317416?v=4" width="100px;" alt=""><br><sub><b>Markus Moser</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://twitter.com/i_sabiq"><img src="https://avatars1.githubusercontent.com/u/19510920?v=4" width="100px;" alt=""><br><sub><b>Sabiq Ihab</b></sub></a></td>
    <td align="center"><a href="http://inbravo.github.io"><img src="https://avatars3.githubusercontent.com/u/5253764?v=4" width="100px;" alt=""><br><sub><b>Amit Dixit</b></sub></a></td>
    <td align="center"><a href="https://github.com/piyushchaudhari04"><img src="https://avatars3.githubusercontent.com/u/10268029?v=4" width="100px;" alt=""><br><sub><b>Piyush Kailash Chaudhari</b></sub></a></td>
    <td align="center"><a href="https://github.com/joshzambales"><img src="https://avatars1.githubusercontent.com/u/8704552?v=4" width="100px;" alt=""><br><sub><b>joshzambales</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://github.com/Crossy147"><img src="https://avatars2.githubusercontent.com/u/7272996?v=4" width="100px;" alt=""><br><sub><b>Kamil Pietruszka</b></sub></a></td>
    <td align="center"><a href="http://cs.joensuu.fi/~zkhayda"><img src="https://avatars2.githubusercontent.com/u/660742?v=4" width="100px;" alt=""><br><sub><b>Zafar Khaydarov</b></sub></a></td>
    <td align="center"><a href="https://kemitix.github.io/"><img src="https://avatars1.githubusercontent.com/u/1147749?v=4" width="100px;" alt=""><br><sub><b>Paul Campbell</b></sub></a></td>
    <td align="center"><a href="https://github.com/Argyro-Sioziou"><img src="https://avatars0.githubusercontent.com/u/22822639?v=4" width="100px;" alt=""><br><sub><b>Argyro Sioziou</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://github.com/TylerMcConville"><img src="https://avatars0.githubusercontent.com/u/4946449?v=4" width="100px;" alt=""><br><sub><b>TylerMcConville</b></sub></a></td>
    <td align="center"><a href="https://github.com/saksham93"><img src="https://avatars1.githubusercontent.com/u/37399540?v=4" width="100px;" alt=""><br><sub><b>saksham93</b></sub></a></td>
    <td align="center"><a href="https://github.com/nikhilbarar"><img src="https://avatars2.githubusercontent.com/u/37332144?v=4" width="100px;" alt=""><br><sub><b>nikhilbarar</b></sub></a></td>
    <td align="center"><a href="http://colinbut.com"><img src="https://avatars2.githubusercontent.com/u/10725674?v=4" width="100px;" alt=""><br><sub><b>Colin But</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://github.com/ruslanpa"><img src="https://avatars2.githubusercontent.com/u/1503411?v=4" width="100px;" alt=""><br><sub><b>Ruslan</b></sub></a></td>
    <td align="center"><a href="https://github.com/JuhoKang"><img src="https://avatars1.githubusercontent.com/u/4745294?v=4" width="100px;" alt=""><br><sub><b>Juho Kang</b></sub></a></td>
    <td align="center"><a href="https://github.com/dheeraj-mummareddy"><img src="https://avatars2.githubusercontent.com/u/7002230?v=4" width="100px;" alt=""><br><sub><b>Dheeraj Mummareddy</b></sub></a></td>
    <td align="center"><a href="https://www.bernardosulzbach.com"><img src="https://avatars0.githubusercontent.com/u/8271090?v=4" width="100px;" alt=""><br><sub><b>Bernardo Sulzbach</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://github.com/4lexis"><img src="https://avatars0.githubusercontent.com/u/19871727?v=4" width="100px;" alt=""><br><sub><b>Aleksandar Dudukovic</b></sub></a></td>
    <td align="center"><a href="https://www.yusufaytas.com"><img src="https://avatars2.githubusercontent.com/u/1049483?v=4" width="100px;" alt=""><br><sub><b>Yusuf Aytaş</b></sub></a></td>
    <td align="center"><a href="http://futurehomes.hu"><img src="https://avatars2.githubusercontent.com/u/1001491?v=4" width="100px;" alt=""><br><sub><b>Mihály Kuprivecz</b></sub></a></td>
    <td align="center"><a href="https://github.com/kapinuss"><img src="https://avatars0.githubusercontent.com/u/17639945?v=4" width="100px;" alt=""><br><sub><b>Stanislav Kapinus</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://github.com/gvsharma"><img src="https://avatars1.githubusercontent.com/u/6648152?v=4" width="100px;" alt=""><br><sub><b>GVSharma</b></sub></a></td>
    <td align="center"><a href="https://github.com/SrdjanPaunovic"><img src="https://avatars1.githubusercontent.com/u/22815104?v=4" width="100px;" alt=""><br><sub><b>Srđan Paunović</b></sub></a></td>
    <td align="center"><a href="https://sideris.xyz/"><img src="https://avatars3.githubusercontent.com/u/5484694?v=4" width="100px;" alt=""><br><sub><b>Petros G. Sideris</b></sub></a></td>
    <td align="center"><a href="https://www.linkedin.com/in/pramodgupta3/"><img src="https://avatars1.githubusercontent.com/u/2184241?v=4" width="100px;" alt=""><br><sub><b>Pramod Gupta</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://amarnath510.github.io/portfolio"><img src="https://avatars0.githubusercontent.com/u/4599623?v=4" width="100px;" alt=""><br><sub><b>Amarnath Chandana</b></sub></a></td>
    <td align="center"><a href="https://github.com/Anurag870"><img src="https://avatars1.githubusercontent.com/u/6295975?v=4" width="100px;" alt=""><br><sub><b>Anurag870</b></sub></a></td>
    <td align="center"><a href="http://theerroris.me"><img src="https://avatars0.githubusercontent.com/u/1685953?v=4" width="100px;" alt=""><br><sub><b>Wes Gilleland</b></sub></a></td>
    <td align="center"><a href="https://github.com/Harshrajsinh"><img src="https://avatars2.githubusercontent.com/u/22811531?v=4" width="100px;" alt=""><br><sub><b>Harshraj Thakor</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://github.com/MaVdbussche"><img src="https://avatars1.githubusercontent.com/u/26136934?v=4" width="100px;" alt=""><br><sub><b>Martin Vandenbussche</b></sub></a></td>
    <td align="center"><a href="https://alexsomai.com"><img src="https://avatars1.githubusercontent.com/u/5720977?v=4" width="100px;" alt=""><br><sub><b>Alexandru Somai</b></sub></a></td>
    <td align="center"><a href="https://github.com/amogozov"><img src="https://avatars3.githubusercontent.com/u/7372215?v=4" width="100px;" alt=""><br><sub><b>Artur Mogozov</b></sub></a></td>
    <td align="center"><a href="https://github.com/anthonycampbell"><img src="https://avatars3.githubusercontent.com/u/10249255?v=4" width="100px;" alt=""><br><sub><b>anthony</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="http://ccygnus.com/"><img src="https://avatars1.githubusercontent.com/u/9342724?v=4" width="100px;" alt=""><br><sub><b>Christian Cygnus</b></sub></a></td>
    <td align="center"><a href="https://about.me/dzmitryh"><img src="https://avatars2.githubusercontent.com/u/5390492?v=4" width="100px;" alt=""><br><sub><b>Dima Gubin</b></sub></a></td>
    <td align="center"><a href="https://github.com/jjjimenez100"><img src="https://avatars3.githubusercontent.com/u/22243493?v=4" width="100px;" alt=""><br><sub><b>Joshua Jimenez</b></sub></a></td>
    <td align="center"><a href="http://about.me/kaiwinter"><img src="https://avatars0.githubusercontent.com/u/110982?v=4" width="100px;" alt=""><br><sub><b>Kai Winter</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://github.com/lbroman"><img src="https://avatars1.githubusercontent.com/u/86007?v=4" width="100px;" alt=""><br><sub><b>lbroman</b></sub></a></td>
    <td align="center"><a href="https://przemeknowak.com"><img src="https://avatars1.githubusercontent.com/u/3254609?v=4" width="100px;" alt=""><br><sub><b>Przemek</b></sub></a></td>
    <td align="center"><a href="https://github.com/prafful1"><img src="https://avatars0.githubusercontent.com/u/14350274?v=4" width="100px;" alt=""><br><sub><b>Prafful Agarwal</b></sub></a></td>
    <td align="center"><a href="https://github.com/sankypanhale"><img src="https://avatars1.githubusercontent.com/u/6478783?v=4" width="100px;" alt=""><br><sub><b>Sanket Panhale</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://github.com/staillebois"><img src="https://avatars0.githubusercontent.com/u/23701200?v=4" width="100px;" alt=""><br><sub><b>staillebois</b></sub></a></td>
    <td align="center"><a href="https://github.com/valdar-hu"><img src="https://avatars3.githubusercontent.com/u/17962817?v=4" width="100px;" alt=""><br><sub><b>Krisztián Nagy</b></sub></a></td>
    <td align="center"><a href="https://www.vanogrid.com"><img src="https://avatars0.githubusercontent.com/u/4307918?v=4" width="100px;" alt=""><br><sub><b>Alexander Ivanov</b></sub></a></td>
    <td align="center"><a href="https://github.com/yosfik"><img src="https://avatars3.githubusercontent.com/u/4850270?v=4" width="100px;" alt=""><br><sub><b>Yosfik Alqadri</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://github.com/7agustibm"><img src="https://avatars0.githubusercontent.com/u/8149332?v=4" width="100px;" alt=""><br><sub><b>Agustí Becerra Milà</b></sub></a></td>
    <td align="center"><a href="https://github.com/Juaanma"><img src="https://avatars3.githubusercontent.com/u/7390500?v=4" width="100px;" alt=""><br><sub><b>Juan Manuel Suárez</b></sub></a></td>
    <td align="center"><a href="http://www.devsedge.net/"><img src="https://avatars0.githubusercontent.com/u/9956006?v=4" width="100px;" alt=""><br><sub><b>Luigi Cortese</b></sub></a></td>
    <td align="center"><a href="https://github.com/Rzeposlaw"><img src="https://avatars2.githubusercontent.com/u/18425745?v=4" width="100px;" alt=""><br><sub><b>Katarzyna Rzepecka</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="http://adamski.pro"><img src="https://avatars1.githubusercontent.com/u/6537430?v=4" width="100px;" alt=""><br><sub><b>adamski.pro</b></sub></a></td>
    <td align="center"><a href="https://github.com/baislsl"><img src="https://avatars0.githubusercontent.com/u/17060584?v=4" width="100px;" alt=""><br><sub><b>Shengli Bai</b></sub></a></td>
    <td align="center"><a href="https://github.com/besok"><img src="https://avatars2.githubusercontent.com/u/29834592?v=4" width="100px;" alt=""><br><sub><b>Boris</b></sub></a></td>
    <td align="center"><a href="https://github.com/dmitraver"><img src="https://avatars3.githubusercontent.com/u/1798156?v=4" width="100px;" alt=""><br><sub><b>Dmitry Avershin</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://github.com/fanofxiaofeng"><img src="https://avatars0.githubusercontent.com/u/3983683?v=4" width="100px;" alt=""><br><sub><b>靳阳</b></sub></a></td>
    <td align="center"><a href="https://github.com/hoangnam2261"><img src="https://avatars2.githubusercontent.com/u/31692990?v=4" width="100px;" alt=""><br><sub><b>hoangnam2261</b></sub></a></td>
    <td align="center"><a href="https://github.com/jarpit96"><img src="https://avatars2.githubusercontent.com/u/10098713?v=4" width="100px;" alt=""><br><sub><b>Arpit Jain</b></sub></a></td>
    <td align="center"><a href="http://joningi.net"><img src="https://avatars2.githubusercontent.com/u/6115148?v=4" width="100px;" alt=""><br><sub><b>Jón Ingi Sveinbjörnsson</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://github.com/kirill-vlasov"><img src="https://avatars3.githubusercontent.com/u/16112495?v=4" width="100px;" alt=""><br><sub><b>Kirill Vlasov</b></sub></a></td>
    <td align="center"><a href="http://mitchell-irvin.com"><img src="https://avatars0.githubusercontent.com/u/16233245?v=4" width="100px;" alt=""><br><sub><b>Mitchell Irvin</b></sub></a></td>
    <td align="center"><a href="https://ranjeet-floyd.github.io"><img src="https://avatars0.githubusercontent.com/u/1992972?v=4" width="100px;" alt=""><br><sub><b>Ranjeet</b></sub></a></td>
    <td align="center"><a href="https://alwayswithme.github.io"><img src="https://avatars3.githubusercontent.com/u/3234786?v=4" width="100px;" alt=""><br><sub><b>PhoenixYip</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://github.com/MSaifAsif"><img src="https://avatars1.githubusercontent.com/u/6280554?v=4" width="100px;" alt=""><br><sub><b>M Saif Asif</b></sub></a></td>
    <td align="center"><a href="https://github.com/kanwarpreet25"><img src="https://avatars0.githubusercontent.com/u/39183641?v=4" width="100px;" alt=""><br><sub><b>kanwarpreet25</b></sub></a></td>
    <td align="center"><a href="http://leonmak.me"><img src="https://avatars3.githubusercontent.com/u/13071508?v=4" width="100px;" alt=""><br><sub><b>Leon Mak</b></sub></a></td>
    <td align="center"><a href="http://www.wramdemark.se"><img src="https://avatars2.githubusercontent.com/u/7052193?v=4" width="100px;" alt=""><br><sub><b>Per Wramdemark</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://github.com/waisuan"><img src="https://avatars2.githubusercontent.com/u/10975700?v=4" width="100px;" alt=""><br><sub><b>Evan Sia Wai Suan</b></sub></a></td>
    <td align="center"><a href="https://github.com/AnaghaSasikumar"><img src="https://avatars2.githubusercontent.com/u/42939261?v=4" width="100px;" alt=""><br><sub><b>AnaghaSasikumar</b></sub></a></td>
    <td align="center"><a href="https://christofferh.com"><img src="https://avatars1.githubusercontent.com/u/767643?v=4" width="100px;" alt=""><br><sub><b>Christoffer Hamberg</b></sub></a></td>
    <td align="center"><a href="https://github.com/dgruntz"><img src="https://avatars0.githubusercontent.com/u/1516800?v=4" width="100px;" alt=""><br><sub><b>Dominik Gruntz</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://bitbucket.org/hannespernpeintner/"><img src="https://avatars3.githubusercontent.com/u/1679437?v=4" width="100px;" alt=""><br><sub><b>Hannes</b></sub></a></td>
    <td align="center"><a href="https://github.com/leogtzr"><img src="https://avatars0.githubusercontent.com/u/1211969?v=4" width="100px;" alt=""><br><sub><b>Leo Gutiérrez Ramírez</b></sub></a></td>
    <td align="center"><a href="https://github.com/npczwh"><img src="https://avatars0.githubusercontent.com/u/14066422?v=4" width="100px;" alt=""><br><sub><b>Zhang WH</b></sub></a></td>
    <td align="center"><a href="https://github.com/oconnelc"><img src="https://avatars0.githubusercontent.com/u/1112973?v=4" width="100px;" alt=""><br><sub><b>Christopher O'Connell</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://github.com/giorgosmav21"><img src="https://avatars2.githubusercontent.com/u/22855493?v=4" width="100px;" alt=""><br><sub><b>George Mavroeidis</b></sub></a></td>
    <td align="center"><a href="https://github.com/hbothra15"><img src="https://avatars1.githubusercontent.com/u/7418012?v=4" width="100px;" alt=""><br><sub><b>Hemant Bothra</b></sub></a></td>
    <td align="center"><a href="https://www.kevinpeters.net/about/"><img src="https://avatars1.githubusercontent.com/u/12736734?v=4" width="100px;" alt=""><br><sub><b>Kevin Peters</b></sub></a></td>
    <td align="center"><a href="https://llorllale.github.io/"><img src="https://avatars1.githubusercontent.com/u/2019896?v=4" width="100px;" alt=""><br><sub><b>George Aristy</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://github.com/mookkiah"><img src="https://avatars1.githubusercontent.com/u/8975264?v=4" width="100px;" alt=""><br><sub><b>Mahendran Mookkiah</b></sub></a></td>
    <td align="center"><a href="https://github.com/Azureyjt"><img src="https://avatars2.githubusercontent.com/u/18476317?v=4" width="100px;" alt=""><br><sub><b>Azureyjt</b></sub></a></td>
    <td align="center"><a href="https://github.com/vehpsr"><img src="https://avatars2.githubusercontent.com/u/3133265?v=4" width="100px;" alt=""><br><sub><b>gans</b></sub></a></td>
    <td align="center"><a href="https://github.com/ThatGuyWithTheHat"><img src="https://avatars0.githubusercontent.com/u/24470582?v=4" width="100px;" alt=""><br><sub><b>Matt</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://www.linkedin.com/in/gopinathlangote/"><img src="https://avatars2.githubusercontent.com/u/10210778?v=4" width="100px;" alt=""><br><sub><b>Gopinath Langote</b></sub></a></td>
    <td align="center"><a href="https://github.com/hoswey"><img src="https://avatars3.githubusercontent.com/u/3689445?v=4" width="100px;" alt=""><br><sub><b>Hoswey</b></sub></a></td>
    <td align="center"><a href="https://github.com/amit2103"><img src="https://avatars3.githubusercontent.com/u/7566692?v=4" width="100px;" alt=""><br><sub><b>Amit Pandey</b></sub></a></td>
    <td align="center"><a href="https://github.com/gwildor28"><img src="https://avatars0.githubusercontent.com/u/16000365?v=4" width="100px;" alt=""><br><sub><b>gwildor28</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://t.me/paul_docker"><img src="https://avatars1.githubusercontent.com/u/2404785?v=4" width="100px;" alt=""><br><sub><b>田浩</b></sub></a></td>
    <td align="center"><a href="https://twitter.com/StPitsios"><img src="https://avatars1.githubusercontent.com/u/6773603?v=4" width="100px;" alt=""><br><sub><b>Stamatis Pitsios</b></sub></a></td>
    <td align="center"><a href="https://github.com/qza"><img src="https://avatars3.githubusercontent.com/u/233149?v=4" width="100px;" alt=""><br><sub><b>qza</b></sub></a></td>
    <td align="center"><a href="http://tschis.github.io"><img src="https://avatars1.githubusercontent.com/u/20662669?v=4" width="100px;" alt=""><br><sub><b>Rodolfo Forte</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://github.com/ankurkaushal"><img src="https://avatars2.githubusercontent.com/u/2236616?v=4" width="100px;" alt=""><br><sub><b>Ankur Kaushal</b></sub></a></td>
    <td align="center"><a href="https://www.linkedin.com/in/ovidijus-okinskas/"><img src="https://avatars0.githubusercontent.com/u/20372387?v=4" width="100px;" alt=""><br><sub><b>Ovidijus Okinskas</b></sub></a></td>
    <td align="center"><a href="https://github.com/robertt240"><img src="https://avatars1.githubusercontent.com/u/9137432?v=4" width="100px;" alt=""><br><sub><b>Robert Kasperczyk</b></sub></a></td>
    <td align="center"><a href="https://github.com/trautonen"><img src="https://avatars3.githubusercontent.com/u/1641063?v=4" width="100px;" alt=""><br><sub><b>Tapio Rautonen</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="http://vk.com/yuri.orlov"><img src="https://avatars0.githubusercontent.com/u/1595733?v=4" width="100px;" alt=""><br><sub><b>Yuri Orlov</b></sub></a></td>
    <td align="center"><a href="https://www.linkedin.com/in/varunu28/"><img src="https://avatars0.githubusercontent.com/u/7676016?v=4" width="100px;" alt=""><br><sub><b>Varun Upadhyay</b></sub></a></td>
    <td align="center"><a href="https://github.com/PalAditya"><img src="https://avatars2.githubusercontent.com/u/25523604?v=4" width="100px;" alt=""><br><sub><b>Aditya Pal</b></sub></a></td>
    <td align="center"><a href="https://github.com/grzesiekkedzior"><img src="https://avatars3.githubusercontent.com/u/23739158?v=4" width="100px;" alt=""><br><sub><b>grzesiekkedzior</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://github.com/sivasubramanim"><img src="https://avatars2.githubusercontent.com/u/51107434?v=4" width="100px;" alt=""><br><sub><b>Sivasubramani M</b></sub></a></td>
    <td align="center"><a href="https://github.com/d4gg4d"><img src="https://avatars2.githubusercontent.com/u/99457?v=4" width="100px;" alt=""><br><sub><b>Sami Airaksinen</b></sub></a></td>
    <td align="center"><a href="https://github.com/vertti"><img src="https://avatars0.githubusercontent.com/u/557751?v=4" width="100px;" alt=""><br><sub><b>Janne Sinivirta</b></sub></a></td>
    <td align="center"><a href="https://github.com/Bobo1239"><img src="https://avatars1.githubusercontent.com/u/2302947?v=4" width="100px;" alt=""><br><sub><b>Boris-Chengbiao Zhou</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://jahhein.github.io"><img src="https://avatars2.githubusercontent.com/u/10779515?v=4" width="100px;" alt=""><br><sub><b>Jacob Hein</b></sub></a></td>
    <td align="center"><a href="https://github.com/iamrichardjones"><img src="https://avatars3.githubusercontent.com/u/14842151?v=4" width="100px;" alt=""><br><sub><b>Richard Jones</b></sub></a></td>
    <td align="center"><a href="https://rachelcarmena.github.io"><img src="https://avatars0.githubusercontent.com/u/22792183?v=4" width="100px;" alt=""><br><sub><b>Rachel M. Carmena</b></sub></a></td>
    <td align="center"><a href="https://zd-zero.github.io"><img src="https://avatars0.githubusercontent.com/u/21978370?v=4" width="100px;" alt=""><br><sub><b>Zaerald Denze Lungos</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://webpro.nl"><img src="https://avatars1.githubusercontent.com/u/456426?v=4" width="100px;" alt=""><br><sub><b>Lars Kappert</b></sub></a></td>
    <td align="center"><a href="https://xiaod.info"><img src="https://avatars2.githubusercontent.com/u/21277644?v=4" width="100px;" alt=""><br><sub><b>Mike Liu</b></sub></a></td>
    <td align="center"><a href="https://github.com/charlesfinley"><img src="https://avatars1.githubusercontent.com/u/6307904?v=4" width="100px;" alt=""><br><sub><b>Matt Dolan</b></sub></a></td>
    <td align="center"><a href="https://github.com/MananS77"><img src="https://avatars3.githubusercontent.com/u/21033516?v=4" width="100px;" alt=""><br><sub><b>Manan</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://github.com/nishant"><img src="https://avatars2.githubusercontent.com/u/15331971?v=4" width="100px;" alt=""><br><sub><b>Nishant Arora</b></sub></a></td>
    <td align="center"><a href="https://github.com/raja-peeyush-kumar-singh"><img src="https://avatars0.githubusercontent.com/u/5496024?v=4" width="100px;" alt=""><br><sub><b>Peeyush</b></sub></a></td>
    <td align="center"><a href="https://github.com/ravening"><img src="https://avatars1.githubusercontent.com/u/10645273?v=4" width="100px;" alt=""><br><sub><b>Rakesh</b></sub></a></td>
    <td align="center"><a href="https://github.com/vINCENT8888801"><img src="https://avatars0.githubusercontent.com/u/8037883?v=4" width="100px;" alt=""><br><sub><b>Wei Seng</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://www.linkedin.com/in/ashish-trivedi-218379135/"><img src="https://avatars3.githubusercontent.com/u/23194128?v=4" width="100px;" alt=""><br><sub><b>Ashish Trivedi</b></sub></a></td>
    <td align="center"><a href="https://rayyounghong.com"><img src="https://avatars1.githubusercontent.com/u/41055099?v=4" width="100px;" alt=""><br><sub><b>洪月阳</b></sub></a></td>
    <td align="center"><a href="https://xdvrx1.github.io/"><img src="https://avatars0.githubusercontent.com/u/47092464?v=4" width="100px;" alt=""><br><sub><b>xdvrx1</b></sub></a></td>
    <td align="center"><a href="http://subho.xyz"><img src="https://avatars0.githubusercontent.com/u/13291222?v=4" width="100px;" alt=""><br><sub><b>Subhrodip Mohanta</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://github.com/nahteb"><img src="https://avatars3.githubusercontent.com/u/13121570?v=4" width="100px;" alt=""><br><sub><b>Bethan Palmer</b></sub></a></td>
    <td align="center"><a href="https://github.com/ToxicDreamz"><img src="https://avatars0.githubusercontent.com/u/45225562?v=4" width="100px;" alt=""><br><sub><b>Toxic Dreamz</b></sub></a></td>
    <td align="center"><a href="http://www.edycutjong.com"><img src="https://avatars1.githubusercontent.com/u/1098102?v=4" width="100px;" alt=""><br><sub><b>Edy Cu Tjong</b></sub></a></td>
    <td align="center"><a href="https://github.com/mkrzywanski"><img src="https://avatars0.githubusercontent.com/u/15279585?v=4" width="100px;" alt=""><br><sub><b>Michał Krzywański</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://www.stefan-birkner.de"><img src="https://avatars1.githubusercontent.com/u/711349?v=4" width="100px;" alt=""><br><sub><b>Stefan Birkner</b></sub></a></td>
    <td align="center"><a href="https://github.com/fedorskvorcov"><img src="https://avatars3.githubusercontent.com/u/43882212?v=4" width="100px;" alt=""><br><sub><b>Fedor Skvorcov</b></sub></a></td>
    <td align="center"><a href="https://github.com/samilAyoub"><img src="https://avatars0.githubusercontent.com/u/61546990?v=4" width="100px;" alt=""><br><sub><b>samilAyoub</b></sub></a></td>
    <td align="center"><a href="https://github.com/vdlald"><img src="https://avatars0.githubusercontent.com/u/29997701?v=4" width="100px;" alt=""><br><sub><b>Vladislav Golubinov</b></sub></a></td>
  </tr>
  <tr>
    <td align="center"><a href="https://github.com/swarajsaaj"><img src="https://avatars2.githubusercontent.com/u/6285049?v=4" width="100px;" alt=""><br><sub><b>Swaraj</b></sub></a></td>
  </tr>
</table>

<!-- markdownlint-enable -->

<!-- prettier-ignore-end -->

<!-- ALL-CONTRIBUTORS-LIST:END -->
