---
layout: pattern
title: Naked Objects
folder: naked-objects
permalink: /patterns/naked-objects/
categories: Architectural
language: en
tags:
 - Decoupling
---

## Intent
The Naked Objects architectural pattern is well suited for rapid
prototyping. Using the pattern, you only need to write the domain objects,
everything else is autogenerated by the framework.

## Class diagram
![alt text](./etc/naked-objects.png "Naked Objects")

## Applicability
Use the Naked Objects pattern when

* You are prototyping and need fast development cycle
* An autogenerated user interface is good enough
* You want to automatically publish the domain as REST services

## Real world examples

* [Apache Isis](https://isis.apache.org/)

## Credits

* [Richard Pawson - Naked Objects](http://downloads.nakedobjects.net/resources/Pawson%20thesis.pdf)
